Subject: Re: 28.0.50; make install with native-comp branch

From: Andrea Corallo <[email-masked]>
Date: Sat, 10 Apr 2021 16:25:28 +0000

Thierry Volpiatto <[email-masked]> writes:

> Andrea Corallo <[email-masked]> writes:
>
>> Eli Zaretskii <[email-masked]> writes:
>>
>>>> From: Thierry Volpiatto <[email-masked]>
>>>> Date: Fri, 26 Feb 2021 08:35:30 +0100
>>>>
>>>> giving a try to native-comp branch.
>>>>
>>>> I install Emacs generaly with:
>>>>
>>>> make install bindir=/usr/local/sbin/emacs-28.0.50 infodir=/usr/local/share/info-28.0.50
>>>>
>>>> This always worked fine.  However with native-comp branch, I have to
>>>> manually add a symlink of "/usr/local/lib/emacs/28.0.50/native-lisp/" to
>>>> "/usr/local/sbin" otherwise I endup with an error:
>>>>
>>>> thierry@IPadS340:/usr/local/sbin/emacs-28.0.50$ ls
>>>> ctags  ebrowse  emacs  emacs-28.0.50  emacsclient  etags
>>>> thierry@IPadS340:/usr/local/sbin/emacs-28.0.50$ ./emacs-28.0.50
>>>> emacs: /usr/local/sbin/emacs-28.0.50/../native-lisp/28.0.50-40158ec0/window-0d1b8b93-738411b0.eln: cannot open shared object file: No such file or directory
>>>> thierry@IPadS340:/usr/local/sbin/emacs-28.0.50$ ./emacs
>>>> emacs: /usr/local/sbin/emacs-28.0.50/../native-lisp/28.0.50-40158ec0/window-0d1b8b93-738411b0.eln: cannot open shared object file: No such file or directory
>>>
>>> Hmm... I'm not sure we can resolve this in any other way, although we
>>> should try.  What worked for you with previous versions was just a
>>> side effect of the implementation detail: how Emacs finds the files it
>>> needs when it starts.  The *.eln files bring more restrictions to the
>>> table, and it could very well be that the symlink trick will be the
>>> only practical solution to such a non-standard installation.
>>>
>>> A possible solution is to set EMACSNATIVELOADPATH in the environment.
>>
>> As the error is while resurrecting from dump I think acting on the load
>> path will not help as in this phase we relocate elns simply by filename.
>>
>> Thierry, are you specifying your custom bindir only when installing or
>> also while building?
>
> Only when installing.
>
>> If the case is the first could you please try again setting bindir
>> also while building?
>
> How, is this allowed or even possible?

make bootstrap bindir=/xxx

I think ATM this should work (would be nice if you could check this),
reading Eli's opinion we may change it tho.

>> Sorry for not responding earlier, I've been in round robin on the issues
>> I had the feeling were higher priority but was still in my todo list :)
>
> No problems, congrats for the huge work.

Thanks

  Andrea